#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "font.ch"

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg, oStat1, oStat2, oBmp, oClone

   oDlg := GuiStdDialog( "GUI Directory Browser" )

   oBmp := XbpBitmap():new():create()
   oBmp:loadFile("BITMAP1.bmp")

   oClone := MyBMP2BMP(oBmp,{64,64 })

   oStat1 := XbpStatic():new( oDlg:drawingArea,, {100, 200 }, {64,64}  )
   oStat1:type    := XBPSTATIC_TYPE_BITMAP
   oStat1:caption := oClone
   oStat1:create()


   oClone := MyBMP2BMP(oBmp,{64,64 },.T.)

   oStat2 := XbpStatic():new( oDlg:drawingArea,, {200, 200 }, {64,64}  )
   oStat2:type    := XBPSTATIC_TYPE_BITMAP
   oStat2:caption := oClone
   oStat2:create()

   oDlg:Show()

   // Event loop
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )

   ENDDO
RETURN

FUNCTION GuiStdDialog( cTitle )
   LOCAL oDlg

   DEFAULT cTitle TO "Standard Dialog Window"

   oDlg          := XbpDialog():new( ,,{10,10}, {600,400},, .F. )
   oDlg:icon     :=  1
   oDlg:taskList := .T.
   oDlg:title    := cTitle
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_DEFPROP_SMALL )

RETURN oDlg


FUNCTION MyBMP2BMP( oBMP, aXbpSize, lreduce )
LOCAL aRectSrc := { 0, 0, 0, 0 }
LOCAL oTiny
LOCAL oPS
LOCAL oRet
LOCAL nBits
LOCAL nPlanes

DEFAULT lreduce TO .F.

   IF aXbpSize[ 2 ] > 0
      //       oHuge := oBMP
      nBits := oBMP:bits
      nPlanes := oBMP:planes
      aRectSrc[ 3 ] := oBMP:xSize
      aRectSrc[ 4 ] := oBMP:ySize

      oPS := XBPPRESSPACE() :new() :Create()
      oTiny := XbpBitmap() :New() :Create()
      oTiny:Make( aXbpSize[ 1 ], aXbpSize[ 2 ], nPlanes, nBits )
      oTiny:presSpace( oPS )

      IF lreduce = .F.
         oBMP:Draw(oPS,{0,0,aXbpSize[1],aXbpSize[2]},,,GRA_BLT_BBO_IGNORE)
         *oBMP:Draw(oPS,{0,0,aXbpSize[1],aXbpSize[2]},,,GRA_BLT_ROP_SRCCOPY)
      ELSE
         //
         // Tip with 4 ???
         //
         oBMP:Draw( oPS, { 0, 0, aXbpSize[ 1 ], aXbpSize[ 2 ] },,, 4 )
      ENDIF

      oRet := oTiny
   ELSE
      oRet := oBMP
   ENDIF

RETURN oRet
